//12.4 Ķʰץǥ
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class EditGraphics extends JPanel {
   CustomGraphics area;
   ButtonPanel bp;
   public EditGraphics(){
      setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));  //Ĥ
      area = new CustomGraphics(this);
      bp = new ButtonPanel();
      add(area);
      add(bp);
   }

   public static void main(String args[]){
      JFrame f  = new JFrame("Draw Editor");
      EditGraphics example = new EditGraphics();
      f.getContentPane().add(example, BorderLayout.CENTER);
      f.pack();
      f.setVisible(true);
   }
}

class ButtonPanel extends JPanel implements ActionListener{
  JButton lineB, rectB, ovalB;
  int type = 'r';    //޷μ, ͤr(ͳ)

  ButtonPanel(){
     setBackground(Color.white);
     rectB = addButton("ͳ");
     ovalB = addButton("ʱ");
     lineB = addButton("ľ");
  }

  JButton addButton(String label){
     JButton button = new JButton(label);
     button.addActionListener(this);
     add(button);
     return button;
  }

  public void actionPerformed(ActionEvent e) {
     Object target = e.getSource(); 
     if (target == rectB) { type = 'r'; }  //޷μͳѤ
     else if (target == ovalB) { type = 'o'; }  //޷μߤ
     else if (target == lineB) { type = 'l'; }  //޷μ
  }
}

class CustomGraphics extends JPanel implements MouseMotionListener, MouseListener {
   int x1, y1, x2, y2, w, h;
   EditGraphics top;
   public CustomGraphics(EditGraphics t){
      top = t;
      setBackground(Color.yellow);
      setMinimumSize(new Dimension(250, 250));  //Ǿ
      setPreferredSize(new Dimension(250, 250));//˾ॵ
      addMouseListener(this);                   //ޥꥹʡ
      addMouseMotionListener(this);            
   }

   public void paintComponent(Graphics g){    
      super.paintComponent(g);
      if(top.bp.type == 'r'){
         g.drawRect(x1, y1, x2-x1, y2-y1);
      } else if (top.bp.type == 'o'){
         g.drawOval(x1, y1, x2-x1, y2-y1);
      } else if (top.bp.type == 'l'){
         g.drawLine(x1,y1,x2,y2);
      }
   }
	
   public void mouseDragged(MouseEvent e){ //ɥåν
       x2 = e.getX();
       y2 = e.getY();
       w = x2-x1;
       h = y2-y1;
       repaint();  
   }
   public void mouseMoved(MouseEvent e){   }

   public void mousePressed(MouseEvent e){ //ޥ򲡤ν
       x1 = e.getX();
       y1 = e.getY();
   }
   public void mouseReleased(MouseEvent e){ }
   public void mouseClicked(MouseEvent e){   }
   public void mouseEntered(MouseEvent e){   }
   public void mouseExited(MouseEvent e){   }
}


