// 12.1
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.text.*;

class Himando extends JPanel implements ActionListener{
  Person hito;               //֥ͥѿ
  JTextField hField,wField;   //ϥեѿ
  JLabel hyoujun,hantei,himando;      //٥ѿ
  NumberFormat fm, pfm;

  Himando(){
     fm = NumberFormat.getInstance();
     pfm = NumberFormat.getPercentInstance();
     setBackground(Color.white);
     setBorder(BorderFactory.createEmptyBorder(20, 20, 20, 20));  
                              //ѥͥμ˶ζ򤪤Ƥߤ䤹
     hField = new JTextField(10);  //ϥեɤ
     wField = new JTextField(10);
     hyoujun = new JLabel();       //٥
     hantei= new JLabel();
     himando= new JLabel();
     hField.addActionListener(this);  //ϥեɤ˥ꥹʡ
     wField.addActionListener(this);
     setLayout(new GridLayout(5,2));  //쥤Ȥ
     add(new JLabel("Ĺ(cm)"));      //ѥͥʤ
     add(hField);                     
     add(new JLabel("ν(Kg)"));
     add(wField);
     add(new JLabel("ɸν(Kg)"));
     add(hyoujun);
     add(new JLabel("(%)"));
     add(himando);
     add(new JLabel("Ƚ"));
     add(hantei);

     hito = new Person();          //֥ͥ
  }

  //ϥեɤreturn줿¹Ԥ᥽å
  public void actionPerformed(ActionEvent e){  
     float f;
     try{
        f = Float.valueOf(hField.getText()).floatValue();
     } catch (NumberFormatException error){ f = 0.0F; }
     hito.setHeight(f);    //Ĺ

     try{
        f=Float.valueOf(wField.getText()).floatValue();
     } catch (NumberFormatException error){ f = 0.0F; }
     hito.setWeight(f);   //νŤ

     doCalc();        
   }

  void doCalc(){
     if(hito.getHeight() == 0) { hField.requestFocus(); }
     else if(hito.getWeight() == 0) { wField.requestFocus(); }
     else {
        hyoujun.setText(fm.format(hito.calcStdWeight()));  //ɸνŤɽ
        himando.setText(pfm.format(hito.calcHimando()));  //٤ɽ
        hantei.setText(hito.judgeHiman()); //٤Ƚ
     }
  }

  public static void main(String args[]) {
     JFrame f = new JFrame("Himando");
     Himando h = new Himando();        //Ƚѥͥ
     Container c = f.getContentPane(); 

     c.add(h, BorderLayout.CENTER);
     f.pack();                        
     f.setVisible(true);
  }
}

class Person{   //ͥ饹
   private float weight;  //νŤǼѿ
   private float height;  //ĹǼѿ

   float getWeight() { return weight; }  //νŤ֤᥽å
   float getHeight() { return height; }  //Ĺ֤᥽å
   void setWeight(float w) { weight = w; }  //νŤꤹ᥽å
   void setHeight(float h) { height = h; }  //Ĺꤹ᥽å

   float calcStdWeight(){ //ɸνŤ׻
      return (height-100)*0.9F;
   }

   float calcHimando(){  //٤׻
      float std = calcStdWeight();
      return (weight-std)/std;
   }

   String judgeHiman(){  //٤Ƚ
      float j = calcHimando();
      if (j < -0.2)  return "餻";
      else if (j >= -0.2 && j <-0.1)  return "餻";
      else if (j >= -0.1 && j <=0.1)  return "";
      else if (j > 0.1 && j <=0.2)  return "꤮";
      else return "ꤹ";
   }
}

